SystemOrganization addCategory: #'Alien-MacOSX-Core'!

AlienLibrary subclass: #ObjCRuntimeRef
	instanceVariableNames: 'classGetClassMethodAlien classGetInstanceMethodAlien objCLookUpClassAlien objCMsgSendAlien selRegisterNameAlien selGetNameAlien objcAllocateClassPairAlien objcRegisterClassPairAlien objcAddMethodAlien objcAddClassAlien objcAddMethodsAlien'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjCRuntimeRef class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/4/2011 14:41'!
CLSCLASS 
	^1! !

!ObjCRuntimeRef class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/4/2011 14:41'!
CLSMETA 
	^2! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/15/2011 10:30'!
class: anObjectiveCClass addMethod: aSelector implementation: aCallback signature: aString
	^self isRuntime2 
		ifTrue: [ 
			self 
				rt2Class: anObjectiveCClass 
				addMethod: aSelector asObjectiveCSelector
				implementation: aCallback thunk
				signature: aString asAlien ]
		ifFalse: [ 
			self 
				rt1Class: anObjectiveCClass 
				addMethod: aSelector asObjectiveCSelector
				implementation: aCallback thunk
				signature: aString asAlien ]
! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:21'!
class: anObjectiveCClass getClassMethod: aSelector 
	| pointer |

	pointer := self classGetClassMethodAlien
		primFFICallResult: (Alien new: 4)
		with: anObjectiveCClass 
		with: aSelector asObjectiveCSelector.

	(pointer := pointer unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid selector ', aSelector asString ].
	
	^ObjectiveCMethod atAddress: pointer! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:22'!
class: anObjectiveCClass getInstanceMethod: aSelector
	| pointer address |
	
	pointer := self classGetInstanceMethodAlien 
		primFFICallResult: (Alien new: 4)
		with: anObjectiveCClass
		with: aSelector asObjectiveCSelector.
			
	(address := pointer unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid selector ', aSelector asString ].
	
	^ObjectiveCMethod atAddress: address! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
classGetClassMethodAlien
	^ classGetClassMethodAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
classGetInstanceMethodAlien
	^ classGetInstanceMethodAlien! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:07'!
createClassDefinitionOnRuntimeOneNamed: className "<String>" superclassName: superclassName "<String> ^<nil | Array of: ObjectiveCClass>"
	"Objective-C 1.0 version of creating a class (10.4 and prior).
	 See CreateClassDefinition in`Objective-C 1 Runtime Reference'.
	 In Leopard, which has the Objective-C 2.0 run-time, we can simply use objc_allocateClassPair."
	| supercls newClass newMetaclass rootClass |

	(supercls := ObjectiveCClassAlien lookup: superclassName) ifNil: [^nil].
	supercls := supercls asObjectiveCClass.
	(ObjectiveCClassAlien lookup: className) ifNotNil: [^nil].

	rootClass := supercls.
	[rootClass superclass notNil] whileTrue:
		[rootClass := rootClass superclass].

	newClass := self newC.
	newMetaclass := self newC.
	newClass isa: newMetaclass.
	newMetaclass isa: rootClass isa.
	newClass info: self class CLSCLASS.
	newMetaclass info: self class CLSMETA.
	newClass objectiveCname: className.
	newMetaclass  objectiveCname: newClass objectiveCname.
	newClass methodLists: ((Alien newC: 4) signedLongAt: 1 put: -1; yourself).
	newMetaclass methodLists: ((Alien newC: 4) signedLongAt: 1 put: -1; yourself).
	newClass superclass: supercls.
	newMetaclass superclass: supercls isa.
	newClass instanceSize: supercls instanceSize.
	newMetaclass instanceSize: newMetaclass superclass instanceSize.

	self objcAddClassAlien 
		primFFICallResult: nil
		with: newClass address.

	^Array with: newClass with: newMetaclass! !

!ObjCRuntimeRef methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/2/2011 15:37'!
initialize 
	super initialize.

	"access operations"
	classGetClassMethodAlien := self alienMethodNamed: 'class_getClassMethod'.
	classGetInstanceMethodAlien := self alienMethodNamed: 'class_getInstanceMethod'.
	objCLookUpClassAlien := self alienMethodNamed: 'objc_lookUpClass'.
	objCMsgSendAlien := self alienMethodNamed: 'objc_msgSend'.
	selRegisterNameAlien := self alienMethodNamed: 'sel_registerName'.
	selGetNameAlien := self alienMethodNamed: 'sel_getName'.
	
	"adding classes/methods operations"
	objcAllocateClassPairAlien := self alienMethodNamed: 'objc_allocateClassPair'.
	objcRegisterClassPairAlien := self alienMethodNamed: 'objc_registerClassPair'.
	objcAddMethodAlien := self alienMethodNamed: 'class_addMethod'.
	objcAddClassAlien := self alienMethodNamed: 'objc_addClass'.
	objcAddMethodsAlien := self alienMethodNamed: 'class_addMethods'.! !

!ObjCRuntimeRef methodsFor: 'testing' stamp: 'EstebanLorenzano 2/4/2011 14:20'!
isRuntime2 
	^self objcAddMethodAlien notNil! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:32'!
libraryName 
	^'libobjc.dylib'! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/3/2011 17:49'!
methodGetTypeEncoding: anObjectiveCMethod
	| charPointerAlien alien |
	alien := self alienMethodNamed: 'method_getTypeEncoding'.
	charPointerAlien := alien 
		primFFICallResult: (Alien new: 4) 
		with: anObjectiveCMethod.
	
	^charPointerAlien addressField ~= 0
		ifTrue: [ charPointerAlien strcpy ] 
		ifFalse: [ nil ] ! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
objCLookUpClassAlien
	^ objCLookUpClassAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
objCMsgSendAlien
	^ objCMsgSendAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddClassAlien
	^ objcAddClassAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
objcAddClassNamed: className "<String>" superclass: superclassName "<String>" into: binaryBlock "<[:class <ObjectiveCClass> :metaclass <ObjectiveCClass>| <^Type>]> ^<Type>"

	^self isRuntime2
		ifTrue: [ self rt2CreateClassNamed: className superclass: superclassName into: binaryBlock ]
		ifFalse: [ self rt1CreateClassNamed: className superclass: superclassName into: binaryBlock ].

! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddMethodAlien
	^ objcAddMethodAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAddMethodsAlien
	^ objcAddMethodsAlien! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcAllocateClassPairAlien
	^ objcAllocateClassPairAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
objcLookup: className "<String> ^<ObjectiveCClassAlien | nil>"
	| classAlien stringAlien |
	self objCLookUpClassAlien 
		primFFICallResult: (classAlien := ObjectiveCClassAlien new)
		with: (stringAlien := className asAlien) pointer.
	stringAlien free.
	^(classAlien unsignedLongAt: 1) ~= 0 ifTrue: [classAlien]! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/28/2010 09:32'!
objcRegisterClassPairAlien
	^ objcRegisterClassPairAlien! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:07'!
rt1Class: anObjectiveCClass "<Alien>" addMethod: selector "<Alien>" implementation: functionPointer "<FFICallbackThunk|Alien>" signature: signature "<String>" 
	
	| methodList |
	self flag: #fixme. 
	self error: 'Not working'.
	methodList := ObjectiveCMethodList newC
						methodCount: 1;
						method: 1 put: (ObjectiveCMethod new
											selector: selector
											methodTypes: (ObjectiveCAlien encodeSimpleSignature: signature) asAlien
											implementation: functionPointer).
	self  objcAddMethodsAlien 
		primFFICallResult: nil
		with: anObjectiveCClass address
		with: methodList address! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 14:43'!
rt1CreateClassNamed: className superclass: superclassName into: binaryBlock
	| classPairOrNil |
	"objc_allocateClasPair unavailable.  use the 1.0 run-time"
	classPairOrNil := self 
		createClassDefinitionOnRuntimeOneNamed: className
		superclassName: superclassName.
	^classPairOrNil isNil
		ifTrue: [ self error: 'Could not create class' ]
		ifFalse: [ binaryBlock valueWithArguments: classPairOrNil ]! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
rt2Class: anObjectiveCClass "<Alien>" addMethod: selectorAlien "<Alien>" implementation: functionPointer "<FFICallbackThunk|Alien>" signature: signatureAlien "<Alien>" 
	| boolAlien |
	self objcAddMethodAlien 
		primFFICallResult: (boolAlien := Alien new: 4)
		with: anObjectiveCClass pointer "It's a Class, I need to pass a pointer to it"
		with: selectorAlien
		with: functionPointer
		with: signatureAlien pointer. "It's a char*, I need to pass a pointer to it"

	(boolAlien unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'class_addMethod failed' ]! !

!ObjCRuntimeRef methodsFor: 'private' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
rt2CreateClassNamed: className superclass: superclassName into: binaryBlock
	"Use the 2.0 run-time to create an ObjectiveC class"
	| classAlien classNameAlien |

	"Create class"
	classAlien := self objcAllocateClassPairAlien
		primFFICallResult: ObjectiveCClassAlien new
		with: (ObjectiveCClassAlien lookup: superclassName)
		with: (classNameAlien := className asAlien) pointer
		with: 0.
	classNameAlien free.
	
	"Assert the class was created"
	classAlien addressField = 0
		ifTrue: [ self error: 'Could not create class' ].
			
	"Execute body creation"
	binaryBlock 
		value: classAlien asObjectiveCClass 
		value: classAlien isa asObjectiveCClass.
	
	"Register class"
	self objcRegisterClassPairAlien 
		primFFICallResult: (Alien new: 4)
		with: classAlien.
			
	^classAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 15:06'!
selGetName: anObjectiveCSelector 
	^self selGetNameAlien
		primFFICallResult: (Alien forPointer: 0)
		with: anObjectiveCSelector! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
selGetNameAlien
	^ selGetNameAlien! !

!ObjCRuntimeRef methodsFor: 'library' stamp: 'EstebanLorenzano 2/4/2011 15:08'!
selRegisterName: aSelector 
	| objectiveCSelector stringAlien |
	
	stringAlien := aSelector asString asAlien.
	objectiveCSelector := self selRegisterNameAlien
		primFFICallResult: ObjectiveCSelector new
		with: stringAlien pointer.
	stringAlien free.

	^objectiveCSelector
	! !

!ObjCRuntimeRef methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/24/2010 08:31'!
selRegisterNameAlien
	^ selRegisterNameAlien! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
asNSString
	| NSString |
	NSString := 'NSString' inObjectiveCFramework: 'Foundation'.
	^self isEmpty
		ifTrue: [NSString string]
		ifFalse: [NSString alloc initWithUTF8String: self isoToUtf8 asAlien pointer]! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
inObjectiveC
	^ObjectiveCClassAlien lookup: self! !

!String methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
inObjectiveCFramework: frameworkName "<String> ^<ObjectiveCClassAlien>"
	^ObjectiveCClassAlien lookup: self inFramework: frameworkName! !

!Symbol methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/8/2011 17:33'!
asObjectiveCSelector
	^ObjectiveCAlien asObjectiveCSelector: self    ! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 08:53'!
asObjectiveCAlien
	^ObjectiveCAlien new 
		unsignedLongAt: 1 put: (self unsignedLongAt: 1);
		yourself     ! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 08:54'!
asObjectiveCSelector 
	^ObjectiveCSelector new 
		unsignedLongAt: 1 put: (self unsignedLongAt: 1);
		yourself	! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:10'!
isAlien 
	^true! !

!Alien methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/8/2011 16:52'!
isObjectiveCNil 
	^(self unsignedLongAt: 1) = 0 ! !

Alien variableByteSubclass: #ObjectiveCAlien
	instanceVariableNames: ''
	classVariableNames: 'ClassSelectorAlien EightByteParameterTypes FourByteParameterTypes MethodTypeCallbackResultMap MethodTypeMap MethodTypeResultMap SelectorTable TypeQualifierCodes TypeQualifiers TypeSizes'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCAlien commentStamp: 'eem 1/7/2008 11:45' prior: 0!
ObjectiveCAliens are references to Objective-C objects.  They transparently forward messages not in their Smalltalk API to their Objective-C objects via  a special doesNotUnderstand: method and relevant Objective-C run-time.!

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/18/2011 10:04'!
argumentListFromMArgs: margs "<ObjectiveCMArgs>" numArgs: numArgs "<Integer>" withSignature: signature "<String> ^<Array>"
	| sigStream offset |
	sigStream := (signature copyAfter: $:) readStream.
	offset := 1.
	^(1 to: numArgs) collect:
		[:ign| | code arg argSize |
		 [TypeQualifiers includes: (code := sigStream next)] whileTrue.
		 code == $S
			ifTrue:
				[arg := ObjectiveCSmalltalkObjectProxy smalltalkObjectForAddress: (margs unsignedLongAt: offset)]
			ifFalse: [
				arg := (MethodTypeMap 
					at: code 
					ifAbsent: [self error: 'unknown code in Objective-C signature']) 
					value.
				argSize := (EightByteParameterTypes includes: code) ifTrue: [ 8 ] ifFalse: [ 4 ].
				arg isAlien 
					ifTrue: [ 
						arg 
							sizeFieldPut: argSize;  
							unsignedLongAt: 1 put: (margs unsignedLongAt: offset) ]
					ifFalse: [
						 arg replaceFrom: 1 to: argSize with: margs startingAt: offset ] ].
		 offset := offset + argSize.
		 code == $^ ifTrue: [ sigStream next ]. "Ignore next"
		 (MethodTypeResultMap 
			at: code 
			ifAbsent: [ [:thing| thing] ]) 
			value: arg ]! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/8/2011 18:12'!
asObjectiveCSelector: aSelector
	"Answer an Alien for the Objective-C selector corresponding to aSelector.
	 Support selectors that clash with Smalltalk selectors and varargs methods.

	 Selectors that clash with Smalltalk (e.g. class), if sent would be understood
	 as regular Smalltalk selectors, and hence not forwarded to Objective-C by the
	 doesNotUnderstand: method.  Support thesde by allowing selectors to begin
	 with ``objectiveC'', and stripping this prefix when finding the corresponding
	 Objective-C selector. 

	Smalltalk has no support for varargs, and as of 10.4 the Mac OS X frameworks
	contain no occurrences of the keywork 'va:'.  So support varargs by stripping
	all trailing occurrences of ``va:''"
	^SelectorTable
		at: aSelector
		ifAbsentPut: [ 
			ObjCRuntimeRef uniqueInstance 
				selRegisterName: (self removePrefixAndSuffixes: aSelector) ]! !

!ObjectiveCAlien class methodsFor: 'instance creation' stamp: 'eem 1/7/2008 16:30'!
dataSize
	^4! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 1/29/2008 11:35'!
encodeSimpleSignature: aString
	"Take a string encoding an Objective-C method signature without argument size or offsets
	 and decorate it with sizes and offsets."
	"ObjectiveCAlien encodeSimpleSignature: '@@::^v'"

	| size offset decoration index prefix ch |
	size := offset := 0.
	decoration := String new writeStream.
	index := 1.
	[TypeQualifiers includes: (ch := aString at: index)] whileTrue: [index := index + 1].
	"Special hack for pointer types."
	ch = $^ ifTrue: [index := index + 1]. "For now handle only a single character following ^"
	prefix := index.
	index := index + 1.
	[index <= aString size] whileTrue:
		[[ch := aString at: index.
		  TypeQualifiers includes: ch] whileTrue: [decoration nextPut: ch. index := index + 1].
		 size := (FourByteParameterTypes includes: ch)
					ifTrue: [4]
					ifFalse:
						[(EightByteParameterTypes includes: ch)
							ifTrue: [8]
							ifFalse: [self error: 'unrecognized or unhandled type character']].
		 index := index + 1.
		 (decoration nextPut: ch) = $^ ifTrue: "Special hack for pointer types."
			[decoration nextPut: (aString at: index). "For now handle only a single character following ^"
			 index := index + 1].
		 decoration print: offset.
		 offset := offset + size].
	^(aString copyFrom: 1 to: prefix), offset printString, (decoration contents)! !

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'eem 2/27/2008 16:45'!
ensureNotifiedAtStartup
	"ObjectiveCAlien needs to be notified at system startup to initialize elements of the Objective-C ABI."
	self ~~ ObjectiveCAlien ifTrue: [^self].
	self ensureNotifiedAtStartupAfter: FFICallbackThunk! !

!ObjectiveCAlien class methodsFor: 'examples' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
exampleNSOpenPanel
	"ObjectiveCAlien exampleNSOpenPanel"
	| panel files |
	('NSApplication' inObjectiveCFramework: 'AppKit') sharedApplication.
	(panel := ('NSOpenPanel' inObjectiveCFramework: 'AppKit') openPanel)
		setAllowsOtherFileTypes: true asAlien;
		setAllowsMultipleSelection: true asAlien;
		setCanChooseDirectories: false asAlien;
		setCanChooseFiles: true asAlien.
	(panel runModalForDirectory: nil asAlien file: nil asAlien types: nil asAlien) = 0 ifTrue:
		[^self].
	files := panel filenames.
	0 to: files count - 1 do:
		[:i|
		Transcript
			cr;
			nextPutAll: (files objectAtIndex: i) UTF8String strcpyUTF8;
			flush]! !

!ObjectiveCAlien class methodsFor: 'examples' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
exampleOpenWindowWithModalAlert
	"ObjectiveCAlien exampleOpenWindowWithModalAlert"
	| NSTitledWindowMask NSClosableWindowMask
	  NSMiniaturizableWindowMask NSResizableWindowMask
	  NSTexturedBackgroundWindowMask
	  NSBackingStoreBuffered
	  app win pool lert rc |
	NSTitledWindowMask := 1 << 0.
	NSClosableWindowMask := 1 << 1.
	NSMiniaturizableWindowMask := 1 << 2.
	NSResizableWindowMask := 1 << 3.
	NSTexturedBackgroundWindowMask := 1 << 8.
	NSBackingStoreBuffered := 2.

	app := ('NSApplication' inObjectiveCFramework: 'AppKit') sharedApplication.
	pool := ('NSAutoreleasePool' inObjectiveCFramework: 'Foundation') alloc init.

	win := ('NSWindow' inObjectiveCFramework: 'AppKit') alloc
			initWithContentRect: (NSRect x: 250 y: 150 width: 300 height: 200)
			styleMask: NSTitledWindowMask | NSClosableWindowMask | NSMiniaturizableWindowMask
					   | NSResizableWindowMask | NSTexturedBackgroundWindowMask
			backing: NSBackingStoreBuffered
			defer: false asAlien.
	win setTitle: 'Hello!!' asNSString.
	lert := ('NSAlert' inObjectiveCFramework: 'AppKit')
				alertWithMessageText: 'Be Alert!!' asNSString
				defaultButton: 'Lerts' asNSString
				alternateButton: 'We' asNSString
				otherButton: 'Need' asNSString
				informativeTextWithFormat: 'some %s & %@' asNSString
				va: 'text' asAlien pointer
				va: 'string' asNSString.

	lert beginSheetModalForWindow: win
		modalDelegate: (ObjectiveCSmalltalkObjectProxy for: (MacOSXExampleModalDelegate new forApplication: app))
		didEndSelector: (self asObjectiveCSelector: #alertDidEnd:returnCode:contextInfo:)
		contextInfo: nil asAlien.
	rc := app runModalForWindow: win.
	win close.
	pool release.
	^rc! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 1/17/2008 11:44'!
frameworkLibraryNameFor: frameworkName
	^'/System/Library/Frameworks/', frameworkName,
			'.framework/Versions/C/', frameworkName! !

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'eem 2/27/2008 16:47'!
initialize
	"self initialize"
	self ensureNotifiedAtStartup.
	self initializeMethodTypeMap.
	self startUp: true! !

!ObjectiveCAlien class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/18/2011 23:16'!
initializeMethodTypeMap
	"self initializeMethodTypeMap"
	"ObjectiveCAlien initializeMethodTypeMap"
	"See /usr/include/objc/objc_class.h and
	 The Objective-C 2.0 Programming Language, Ch 12: The Runtime System, sec: Type Encodings."
	MethodTypeMap := IdentityDictionary new: 32.
	MethodTypeMap
		at: $@ "_C_ID"			put: [ObjectiveCAlien new];
		at: $# "_C_CLASS"		put: [ObjectiveCClassAlien new];
		at: $: "_C_SEL"			put: [Alien new: 4];
		at: $c "_CHR"			put: [Alien new: 1];
		at: $C "_C_UCHR"		put: [Alien new: 1];
		at: $s "_C_SHT"			put: [Alien new: 2];
		at: $S "_C_USHT"		put: [Alien new: 2];
		at: $i "_C_INT"			put: [Alien new: 4];
		at: $I "_C_UINT"			put: [Alien new: 4];
		at: $l "_C_LNG"			put: [Alien new: 4];
		at: $L "_C_ULNG"		put: [Alien new: 4];
		at: $f "_C_FLT"			put: [Alien new: 4];
		at: $d "_C_DBL"			put: [Alien new: 8];
		"at: $b" "_C_BFLD"		"put: [];"
		at: $v "_C_VOID"		put: nil;
		"at: $?" "_C_UNDEF"	"put: [];"
		at: $^ "_C_PTR"			put: [Alien forPointer: 0];
		at: $* "_CHARPTR"		put: [Alien forPointer: 0];
		"at: $[" "_C_ARY_B"	"put: [];"
		"at: $]" "_C_ARY_E"	"put: [];"
		"at: $(" "_C_UNION_B"	"put: [];"
		"at: $)" "_C_UNION_E"	"put: [];"
		at: ${ "_C_STRUCT_B" 	put: nil.
		"at: $}" "_C_STRUCT_E""put: []."

	FourByteParameterTypes := '@#:cCsSiIlLf^*'.
	EightByteParameterTypes := 'd'.

"#define _C_CONST			'r'
#define _C_IN				'n'
#define _C_INOUT			'N'
#define _C_OUT			'o'
#define _C_BYCOPY		'O'
#define _C_BYREF			'R'
#define _C_ONEWAY		'V'
#define _C_GCINVISIBLE	'!!'
"
	TypeQualifiers := 'nNoOrRV!!'.
	TypeQualifierCodes := TypeQualifiers asByteArray.
					
	MethodTypeResultMap := IdentityDictionary new: 32.
	MethodTypeResultMap
		at: $c "_CHR"			put: [:alien| alien unsignedByteAt: 1];
		at: $C "_C_UCHR"		put: [:alien| alien unsignedByteAt: 1];
		at: $s "_C_SHT"			put: [:alien| alien signedShortAt: 1];
		at: $S "_C_USHT"		put: [:alien| alien unsignedShortAt: 1];
		at: $i "_C_INT"			put: [:alien| alien signedLongAt: 1];
		at: $I "_C_UINT"			put: [:alien| alien unsignedLongAt: 1];
		at: $l "_C_LNG"			put: [:alien| alien signedLongAt: 1];
		at: $L "_C_ULNG"		put: [:alien| alien unsignedLongAt: 1];
		at: $f "_C_FLT"			put: [:alien| alien floatAt: 1];
		at: $d "_C_DBL"			put: [:alien| alien doubleAt: 1].

	MethodTypeCallbackResultMap := IdentityDictionary new: 32.
	MethodTypeCallbackResultMap
		at: $v 					put: [ :value | nil ] ;
		at: $c "_CHR"			put: [ :value | value asInteger] ;
		at: $C "_C_UCHR"		put: [ :value | value asInteger ];
		at: $s "_C_SHT"			put: [ :value | value asInteger ];
		at: $S "_C_USHT"		put: [ :value | value asInteger ];
		at: $i "_C_INT"			put: [ :value | value asInteger ];
		at: $I "_C_UINT"			put: [ :value | value asInteger ];
		at: $l "_C_LNG"			put: [ :value | value asInteger ];
		at: $L "_C_ULNG"		put: [ :value | value asInteger ];
		at: $f "_C_FLT"			put: [ :value | value asFloat ];
		at: $d "_C_DBL"			put: [ :value | value asFloat ].

	TypeSizes := IdentityDictionary new: 32.
	TypeSizes
		at: $c "_CHR"			put: [ self sizeofChar ] ;
		at: $C "_C_UCHR"		put: [ self sizeofChar ];
		at: $s "_C_SHT"			put: [ self sizeofShort ];
		at: $S "_C_USHT"		put: [ self sizeofShort ];
		at: $i "_C_INT"			put: [ self sizeofInt ];
		at: $I "_C_UINT"			put: [ self sizeofInt ];
		at: $l "_C_LNG"			put: [ self sizeofLong ];
		at: $L "_C_ULNG"		put: [ self sizeofLong ];
		at: $f "_C_FLT"			put: [ self sizeofFloat ];
		at: $d "_C_DBL"			put: [ self sizeofDouble ];
		at: $^					put: [ self sizeofPointer ].
! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 2/12/2008 16:58'!
lookup: globalOrClassName "<String>" inFramework: frameworkName "<String> ^<ObjectiveCClassAlien | ObjectiveCClassAlien | nil>"
	"Looks up a global or a class and answers a suitable Alien.
	 If receiver is ObjectiveCAlien result is an ObjectiveCAlien for some global variable (e.g. NSApp).
	 If receiver is ObjectiveCClassAlien result is an ObjectiveCClassAlien for some class (e.g. NSApplication).
	 i.e. the client must know whether they're asking for a global or a class."
	^self
		lookup: globalOrClassName
		inLibrary: (self frameworkLibraryNameFor: frameworkName)! !

!ObjectiveCAlien class methodsFor: 'private' stamp: 'EstebanLorenzano 2/8/2011 18:12'!
removePrefixAndSuffixes: aSelector 
	"Remove the prefixes and sufixes added to a selector for make it compatible with ObjectiveC. 
	 For example: objectiveCclass will call the objC method #class, not thos one. 
	 and printf: aString va: 'some1' va: 'some2' will call printf with corresponding varargs"
	| selectorString stringAlien objectiveCSelector |
	
	selectorString := aSelector asString.
	
	"Remove prefix"
	selectorString := (selectorString beginsWith: 'objectiveC')
		ifTrue: [ selectorString copyFrom: 11 to: aSelector size ]
		ifFalse: [ selectorString ].
	
	"Remove suffixes (for var args)"
	[selectorString endsWith: 'va:'] 
		whileTrue: [ selectorString := selectorString copyFrom: 1 to: selectorString size - 3 ].
		
	^selectorString! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/18/2011 11:36'!
returnForCallback: anObject withSignature: signature "<String> ^<Alien>"
	^(MethodTypeCallbackResultMap 
		at: (signature first)
		ifAbsent: [ [ :thing | thing ] ]) 
			value: anObject. 
	! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/18/2011 23:22'!
returnStructSizeForMethodTypes: methodTypes "<char * Alien> ^<Character>"
	"Answer the return size of an Objective-C method given an Alien for its method_types."
	| returnType types typeStream size |
	
	self flag: #todo. "This method maybe needs to be optimized. It depends on the access to structs in 
	the system, which can be big... easiest way is to cache the returnType, size and skips the full parse
	and matching of types"
	
	returnType := (methodTypes strcpy copyUpToLast: $}) allButFirst.
	types := ((returnType subStrings: '{}=') reject: [ :each | each beginsWith: '_' ])
		inject: String new 
		into: [ :all :each | all, each ].
		
	size := 0.
	typeStream := types readStream.
	[ typeStream atEnd ] 
		whileFalse: [ 
			| type |
			type := typeStream next. 
			size := size + (TypeSizes at: type) value.
			type = $^ ifTrue: [ typeStream next ] ].
	^size! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 1/13/2011 12:28'!
returnTypeCharacterForMethodTypes: methodTypes "<char * Alien> ^<Character>"
	"Answer the return type of an Objective-C method given an Alien for its method_types."
	| index code |
	index := 1.
	[ TypeQualifierCodes includes: (code := methodTypes unsignedByteAt: index) ] 
		whileTrue: [ index := index + 1 ].
	^Character value: code! !

!ObjectiveCAlien class methodsFor: 'system startup' stamp: 'EstebanLorenzano 2/4/2011 14:53'!
startUp: resuming
	(resuming and: [SmalltalkImage current platformName = 'Mac OS'])
		ifFalse: [^ self].

	SelectorTable := Dictionary new 
! !

!ObjectiveCAlien class methodsFor: 'objective-c run-time' stamp: 'eem 2/12/2008 22:02'!
valueOfDatum: global "<String>" inFramework: frameworkName "<String> ^<ObjectiveCClassAlien | nil>"
	"Fetches the value of a global and answers an ObjectiveCAlien."
	^self forPointer: ((self
						lookup: global
						inLibrary: (self frameworkLibraryNameFor: frameworkName))
							unsignedLongAt: 1)! !

!ObjectiveCAlien methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/4/2011 18:11'!
descriptionString 
	^self description UTF8String strcpy! !

!ObjectiveCAlien methodsFor: 'message forwarding' stamp: 'EstebanLorenzano 2/18/2011 22:54'!
doesNotUnderstand: aMessage
	| method returnTypeCharacter result |
	method := self objectiveCMethodForSelectorAlien: aMessage selector.
	method isNil 
		ifTrue: [
		 "Might also check if selector is not already forward: and if
		  so try sending forward: of the selector and arguments?"
		 ^super doesNotUnderstand: aMessage].
	
	returnTypeCharacter := self class returnTypeCharacterForMethodTypes: method methodTypes.
	"If MethodTypeMap doesn't include returnTypeCharacter then we haven't
	implemented handling that return type yet."
	result := (MethodTypeMap at: returnTypeCharacter) value.
	"Structure types are a special case... they need to be answered as C Heap Aliens"
	returnTypeCharacter = ${
		ifTrue: [ 
			result := Alien newGC: (self class returnStructSizeForMethodTypes: method methodTypes).
			method implementation
				primFFICallResult: nil
				withArguments: {result pointer. self. method rawSelector}, aMessage arguments ]
		ifFalse: [
			result := method implementation
				primFFICallResult: result
				withArguments: {self. method rawSelector}, aMessage arguments ].
		
	"If it returns void, we adopt it to Smalltalk style and answer self"
	^returnTypeCharacter = $v 
		ifTrue: [ self ]
		ifFalse: 	[ (MethodTypeResultMap at: returnTypeCharacter ifAbsent: [^result]) value: result ]! !

!ObjectiveCAlien methodsFor: 'coercing' stamp: 'eem 2/7/2008 09:01'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

!ObjectiveCAlien methodsFor: 'accessing' stamp: 'eem 2/7/2008 16:23'!
isa
	| address |
	^(address := self unsignedLongAt: 1) ~= 0 ifTrue:
		[ObjectiveCClassAlien forPointer: ((Alien forPointer: address) unsignedLongAt: 1)]! !

!ObjectiveCAlien methodsFor: 'attic' stamp: 'EstebanLorenzano 2/4/2011 15:09'!
objectiveCClass
	"Obsolete; see isa.  But kept for reference."
	^self objCMsgSendAlien
		primFFICallResult: ObjectiveCAlien new
		with: self
		with: #objectiveCclass asObjectiveCSelector! !

!ObjectiveCAlien methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/17/2011 17:26'!
objectiveCMethodForSelectorAlien: aSelector
	^ObjCRuntimeRef uniqueInstance 
		class: self isa 
		getInstanceMethod: aSelector! !

ObjectiveCAlien variableByteSubclass: #ObjectiveCClassAlien
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCClassAlien commentStamp: 'eem 1/8/2008 09:54' prior: 0!
ObjectiveCAliens are references to Objective-C class objects.  They transparently forward messages not in their Smalltalk API to theirrespective Objective-C class objects as do instances of ObjectiveCAlien.  The difference is due to ObjectiveC's lack of metaclasses.  Hence class methods must be looked up using class_getClassMethod, whereas in ObjectiveCAlien they are looked up using class_getInstanceMethod.!

!ObjectiveCClassAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/4/2011 14:40'!
lookup: className
	^ObjCRuntimeRef uniqueInstance objcLookup:  className  ! !

!ObjectiveCClassAlien class methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 12/24/2010 08:39'!
lookup: className "<String>" inLibrary: aLibraryName "<String> ^<ObjectiveCClassAlien | nil>"
	"self ensureLoaded: aLibraryName."
	^self lookup: className! !

!ObjectiveCClassAlien methodsFor: 'converting' stamp: 'eem 1/30/2008 14:30'!
asObjectiveCClass
	"Answer a struct objc_class object (ObjectiveCClass) for the receivers class."
	^ObjectiveCClass atAddress: (self unsignedLongAt: 1)! !

!ObjectiveCClassAlien methodsFor: 'objective-c run-time' stamp: 'EstebanLorenzano 2/4/2011 14:10'!
objectiveCMethodForSelectorAlien: aSelector
	^ObjCRuntimeRef uniqueInstance 
		class: self 
		getClassMethod: aSelector! !

Alien variableByteSubclass: #ObjectiveCForwardSignature
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCForwardSignature commentStamp: 'eem 1/24/2008 18:23' prior: 0!
Signature of Objective-C Object's forward:: method:

- forward: (SEL)sel : (marg_list)args
== forward(id receiver, SEL forwardSel, SEL selectorToForward, marg_list args)!

!ObjectiveCForwardSignature class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/13/2011 17:45'!
dataSize
	"id receiver, SEL command, marg_list args)"
	^12! !

!ObjectiveCForwardSignature methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2011 09:50'!
args
	^ObjectiveCMArgs forPointer: self address + 8  ! !

!ObjectiveCForwardSignature methodsFor: 'accessing' stamp: 'eem 1/24/2008 18:24'!
receiverAddress
	^self unsignedLongAt: 1! !

!ObjectiveCForwardSignature methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/8/2011 18:21'!
selector
	^ObjectiveCSelector new 
		unsignedLongAt: 1 put: (self unsignedLongAt: 5)
		yourself! !

!ObjectiveCForwardSignature methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/8/2011 17:24'!
sender
	^ObjectiveCAlien atAddress: (self receiverAddress)  ! !

Alien variableByteSubclass: #ObjectiveCMArgs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMArgs commentStamp: '<historical>' prior: 0!
This class's instances are wrappers around Objective-C margs parameters of the forward:: method.,

WARNING!! va_list mangling has changed in gcc 4.4... so this can stop working anytime. !

!ObjectiveCMArgs class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/8/2011 18:44'!
dataSize 
	^4! !

!ObjectiveCMArgs methodsFor: 'convenience' stamp: 'EstebanLorenzano 2/15/2011 09:55'!
at: indexNumber
	^self 
		at: indexNumber
		kind: Alien
		dataSize: 4 "An object or a pointer"! !

!ObjectiveCMArgs methodsFor: 'convenience' stamp: 'EstebanLorenzano 2/15/2011 09:55'!
at: indexNumber dataSize: sizeNumber
	^self 
		at: indexNumber
		kind: Alien 
		dataSize: sizeNumber! !

!ObjectiveCMArgs methodsFor: 'convenience' stamp: 'EstebanLorenzano 2/15/2011 09:55'!
at: indexNumber kind: alienClass
	^self 
		at: indexNumber
		kind: alienClass 
		dataSize: alienClass dataSize! !

!ObjectiveCMArgs methodsFor: 'convenience' stamp: 'EstebanLorenzano 2/8/2011 18:53'!
at: indexNumber kind: alienClass dataSize: sizeNumber 
	^(alienClass new: sizeNumber)
		unsignedLongAt: 1 put: (self unsignedLongAt: indexNumber);
		yourself  ! !

Alien variableByteSubclass: #ObjectiveCMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMethod commentStamp: 'eem 1/7/2008 16:32' prior: 0!
/*
 *  Method Template
 */
typedef struct objc_method *Method;

struct objc_method {
    SEL method_name;
    char *method_types;
    IMP method_imp;
};
!

!ObjectiveCMethod class methodsFor: 'instance creation' stamp: 'eem 1/7/2008 16:31'!
dataSize
	"typedef struct objc_method *Method;

	struct objc_method {
	    SEL method_name;
	    char *method_types;
	    IMP method_imp;
	};"

	^12! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:34'!
implementation
	^Alien forPointer: (self unsignedLongAt: 9)! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:55'!
methodTypes
	^Alien forPointer: (self unsignedLongAt: 5)! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:34'!
methodTypesString
	^(Alien forPointer: (self unsignedLongAt: 5)) strcpy! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'eem 1/29/2008 11:08'!
rawSelector
	^self unsignedLongAt: 1! !

!ObjectiveCMethod methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2011 16:42'!
selector
	^ObjectiveCSelector forPointer: (self unsignedLongAt: 1)! !

!ObjectiveCMethod methodsFor: 'instance initalization' stamp: 'eem 1/29/2008 15:03'!
selector: selector "<ObjectiveCAlien>" methodTypes: string "<char * Alien>" implementation: functionPointer "<id (*IMP)(id, SEL, ...) Alien> ^<self>"
	self unsignedLongAt: 1 put: (selector unsignedLongAt: 1).
	self unsignedLongAt: 5 put: string address.
	self unsignedLongAt: 9 put: (functionPointer unsignedLongAt: 1)! !

Alien variableByteSubclass: #ObjectiveCMethodList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCMethodList commentStamp: 'eem 1/10/2008 18:27' prior: 0!
struct objc_method_list {
    struct objc_method_list *obsolete;

    int method_count;
#ifdef __alpha__
    int space;
#endif
    struct objc_method method_list[1];  /* variable length structure */
};
!

!ObjectiveCMethodList class methodsFor: 'instance creation' stamp: 'eem 1/29/2008 13:09'!
dataSize
	^20
	
"struct objc_method_list {
    struct objc_method_list *obsolete;

    int method_count;
#ifdef __alpha__
    int space;
#endif
    struct objc_method method_list[1];  /* variable length structure */
};
"! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/29/2008 12:01'!
method: oneRelativeIndex "<Integer>" put: method "<ObjectiveCMethod>"
	| methodsBaseIndex |
	methodsBaseIndex := 9 + (oneRelativeIndex - 1 * ObjectiveCMethod dataSize).
	self
		unsignedLongAt: methodsBaseIndex put: (method unsignedLongAt: 1);
		unsignedLongAt: methodsBaseIndex + 4 put: (method unsignedLongAt: 5);
		unsignedLongAt: methodsBaseIndex + 8 put: (method unsignedLongAt: 9).! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/28/2008 12:45'!
methodCount
	^self signedLongAt: 5! !

!ObjectiveCMethodList methodsFor: 'accessing' stamp: 'eem 1/29/2008 11:57'!
methodCount: anInteger
	self signedLongAt: 5 put: anInteger! !

Alien variableByteSubclass: #ObjectiveCObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCObject commentStamp: 'eem 1/24/2008 13:04' prior: 0!
Access to the raw structure of an ObjectiveC object.  Do not confuse this with ObjectiveCAlien, wich is a Smalltalk proxy for an ObjectiveC object.  This is an indirect object (a struct, if you like); ObjectiveCAlien is a direct pointer to an object (a reference to an Objective-C object).

@interface Object
{
    Class isa;  /* A pointer to the instance's class structure */
}

Effectively:
struct objc_object {
    struct objc_class *isa;
};
!

ObjectiveCObject variableByteSubclass: #ObjectiveCClass
	instanceVariableNames: ''
	classVariableNames: 'CLSCLASS CLSMETA'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCClass commentStamp: 'eem 1/10/2008 18:07' prior: 0!
/*
 *  Class Template
 */
struct objc_class {
    struct objc_class *isa;
    struct objc_class *super_class;
    const char *name;
    long version;
    long info;
    long instance_size;
    struct objc_ivar_list *ivars;

    struct objc_method_list **methodLists;

    struct objc_cache *cache;
    struct objc_protocol_list *protocols;
};
!

!ObjectiveCClass class methodsFor: 'class creation' stamp: 'EstebanLorenzano 2/4/2011 14:38'!
createClassNamed: className "<String>" superclass: superclassName "<String>" into: binaryBlock "<[:class <ObjectiveCClass> :metaclass <ObjectiveCClass>| <^Type>]> ^<Type>"
	^ObjCRuntimeRef uniqueInstance 
		objcAddClassNamed: className 
		superclass: superclassName   
		into: binaryBlock! !

!ObjectiveCClass class methodsFor: 'instance creation' stamp: 'eem 1/10/2008 18:07'!
dataSize
	^40

"/*
 *  Class Template
 */
struct objc_class {
    struct objc_class *isa;
    struct objc_class *super_class;
    const char *name;
    long version;
    long info;
    long instance_size;
    struct objc_ivar_list *ivars;

    struct objc_method_list **methodLists;

    struct objc_cache *cache;
    struct objc_protocol_list *protocols;
};"! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/4/2011 14:28'!
addMethod: aSelector signature: aString implementation: aCallback
	ObjCRuntimeRef uniqueInstance 
		class: self	
		addMethod: aSelector 
		implementation: aCallback
		signature: aString! !

!ObjectiveCClass methodsFor: 'coercing' stamp: 'eem 1/30/2008 14:30'!
asObjectiveCClassAlien
	"Answer an ObjectiveC object for the receiver's struct objc_class."
	^ObjectiveCClassAlien atAddress: self address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:00'!
info: anInteger 
	self signedLongAt: 17 put: anInteger! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:19'!
instanceSize
	^self signedLongAt: 21! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:19'!
instanceSize: anInteger 
	self signedLongAt: 21 put: anInteger! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:17'!
methodLists: anAlien "<ObjectiveCMethodLists>" 
	self unsignedLongAt: 29 put: anAlien address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:24'!
objectiveCname "^<Alien char *>"
	^Alien
		atAddress: (self unsignedLongAt: 9)
		dataSize: (self strlenThroughPointerAt: 9) + 1! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 22:05'!
objectiveCname: anAlienOrString
	self unsignedLongAt: 9 put: anAlienOrString asAlien address! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/30/2008 14:30'!
superclass
	| address |
	^(address := self unsignedLongAt: 5) = 0 ifFalse:
		[ObjectiveCClass atAddress: address]! !

!ObjectiveCClass methodsFor: 'accessing' stamp: 'eem 1/10/2008 21:48'!
superclass: anAlienOrNil
	self unsignedLongAt: 5 put: (anAlienOrNil isNil ifTrue: [0] ifFalse: [anAlienOrNil address])! !

!ObjectiveCObject class methodsFor: 'instance creation' stamp: 'eem 1/24/2008 13:01'!
dataSize
	^4! !

!ObjectiveCObject methodsFor: 'coercing' stamp: 'eem 2/7/2008 09:05'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

!ObjectiveCObject methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2011 12:49'!
isa
	| address |
	(address := self unsignedLongAt: 1) = 0 
		ifTrue: [ self error: 'Invalid address' ].
	^ObjectiveCClass atAddress: address! !

!ObjectiveCObject methodsFor: 'accessing' stamp: 'eem 2/7/2008 09:06'!
isa: anObjectiveCClassAlienOrNil
	self unsignedLongAt: 1 put: anObjectiveCClassAlienOrNil id! !

ObjectiveCObject variableByteSubclass: #ObjectiveCSmalltalkObjectProxy
	instanceVariableNames: ''
	classVariableNames: 'AddressToBothInstancesMap ObjectiveCSmalltalkProxyClassAlien RespondsToSelectorCallback SendbackCallback SmalltalkToObjectiveCInstanceMap'
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCSmalltalkObjectProxy commentStamp: 'eem 2/12/2008 13:12' prior: 0!
This class handles forwarding messages from Objective-C back into Smalltalk.  It creates a class in Objective-C that has a forward: instance method. Its instances exist only in Objective-C.  The class variable AddressToBothInstancesMap is keyed by Objective-C instance address and has pairs of {ObjectiveCSmalltalkObjectProxy, Smalltalk object} as instances.  The Objective-C methods (forward: and ...) of ObjectiveCSmalltalkProxy are FFI callbacks.

/*
 *  Class Template
 */
struct ObjectiveCSmalltalkProxy {
    struct objc_class *isa;
};
!

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/15/2011 10:00'!
addMethodForwardInvocationTo: alienClass
	"SendbackCallback is here simply to prevent the Callback being garbage collected and the 
	 thunk being finalized as a result."
	alienClass
		addMethod: #forwardInvocation:
		signature: '@@:@' 
		implementation: (SendbackCallback := Callback
			block: [:args :resultAlien| | pair result |
				pair := AddressToBothInstancesMap at: args receiverAddress.
				result := pair first forward: args selector to: pair last with: args args.
				resultAlien returnInteger: (self for: result) addressField]
			argsClass: ObjectiveCForwardSignature)! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/15/2011 11:02'!
addMethodRespondsToSelectorTo: classAlien
	classAlien
		addMethod: #respondsToSelector:
		signature: 'c@:^v'
		implementation: (RespondsToSelectorCallback := Callback 
			block: [ :args :resultAlien | resultAlien returnInteger: 0 ]
			argsClass: ObjectiveCForwardSignature).! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'instance creation' stamp: 'eem 1/24/2008 16:06'!
dataSize
"/*
   *  Class Template
   */
struct ObjectiveCSmalltalkProxy {
    struct objc_class *isa;
};"
	^4! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'class initialization' stamp: 'eem 2/27/2008 16:45'!
ensureNotifiedAtStartup
	"ObjectiveCSmalltalkProxy needs to be notified at system startup to initialize elements of the Objective-C ABI."
	self ~~ ObjectiveCSmalltalkObjectProxy ifTrue: [^self].
	self ensureNotifiedAtStartupAfter: ObjectiveCClass! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'instance creation' stamp: 'eem 2/12/2008 13:08'!
for: anObject "<Object> ^<ObjectiveCSmalltalkObjectProxy>"
	^SmalltalkToObjectiveCInstanceMap
		at: anObject
		ifAbsentPut:
			[| proxy |
			AddressToBothInstancesMap
				at: (proxy := self new) addressField
				put: {proxy. anObject}.
			proxy]! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'class initialization' stamp: 'eem 2/27/2008 16:47'!
initialize
	"self initialize"
	self ensureNotifiedAtStartup.
	self startUp: true! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/4/2011 18:25'!
installSmalltalkProxyClass
	"ObjectiveCSmalltalkObjectProxy installSmalltalkProxyClass"

	ObjectiveCClass
		createClassNamed: 'SmalltalkProxy'
		superclass: 'NSObject'
		into: [:theClass :theMetaclass|
			self addMethodRespondsToSelectorTo: theClass.			
			self addMethodForwardInvocationTo: theClass ].
	ObjectiveCSmalltalkProxyClassAlien := ObjectiveCClassAlien lookup: 'SmalltalkProxy'! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'instance creation' stamp: 'eem 2/7/2008 10:51'!
new "^<ObjectiveCSmalltalkObjectProxy>"
	^(self forPointer: (self Cmalloc: self dataSize)) initialize! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'instance creation' stamp: 'eem 2/7/2008 10:20'!
new: dataSize "<Integer>"
	"Use for: instead"
	self shouldNotImplement! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'instance creation' stamp: 'eem 2/7/2008 10:20'!
newC: dataSize "<Integer>"
	"Use for: instead"
	self shouldNotImplement! !

!ObjectiveCSmalltalkObjectProxy class methodsFor: 'system startup' stamp: 'eem 2/12/2008 13:20'!
startUp: resuming
	"Partially initialize, clearing the mapping tables.
	Leave installing the proxy class to the instance side's intialize
	method, hence making initialization as lazy as possible."

	"ObjectiveCSmalltalkObjectProxy startUp: true"
	resuming ifFalse: [^self].
	AddressToBothInstancesMap := Dictionary new.
	SmalltalkToObjectiveCInstanceMap := IdentityDictionary new.
	ObjectiveCSmalltalkProxyClassAlien := nil. "acts as initialization flag."
	"This code now moved to ObjectiveCSmalltalkObjectProxy>>initialize."
	"SmalltalkImage current platformName = 'Mac OS' ifFalse: [^self].
	self installSmalltalkProxyClass"! !

!ObjectiveCSmalltalkObjectProxy methodsFor: 'converting' stamp: 'EstebanLorenzano 2/4/2011 18:10'!
asObjectiveCAlien
	^ObjectiveCAlien atAddress: (self unsignedLongAt: 1)! !

!ObjectiveCSmalltalkObjectProxy methodsFor: 'message forwarding' stamp: 'eem 2/13/2008 15:27'!
forward: anObjectiveCSelectorAlien to: aSmalltalkObject with: anObjectiveCMArgs "^<Object>"
	| smalltalkSelector args method pragmas |
	smalltalkSelector := anObjectiveCSelectorAlien asSmalltalkSelector.
	args :=  ObjectiveCAlien
				argumentListFromMArgs: anObjectiveCMArgs
				numArgs: smalltalkSelector numArgs
				withSignature: (((method := aSmalltalkObject class lookupSelector: smalltalkSelector) notNil
								and: [(pragmas := method pragmas select: [:p| p keyword == #objectiveCSignature:]) notEmpty])
									ifTrue: [pragmas anyOne arguments first]
									ifFalse: [String new: smalltalkSelector numArgs withAll: $S]).
	^aSmalltalkObject
		perform: smalltalkSelector
		withArguments: args! !

!ObjectiveCSmalltalkObjectProxy methodsFor: 'instance initalization' stamp: 'EstebanLorenzano 2/15/2011 11:05'!
initialize
	ObjectiveCSmalltalkProxyClassAlien 
		ifNil: [
			"acts as initialization flag."
			self class installSmalltalkProxyClass ].
	self isa: ObjectiveCSmalltalkProxyClassAlien! !

!ObjectiveCSmalltalkObjectProxy methodsFor: 'memory management' stamp: 'EstebanLorenzano 1/13/2011 13:07'!
release
	| pair |
	pair := AddressToBothInstancesMap removeKey: self addressField ifAbsent: [].
	SmalltalkToObjectiveCInstanceMap removeKey: pair last ifAbsent: [].
	self free! !

Alien variableByteSubclass: #ObjectiveCSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCSelector class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/8/2011 17:12'!
dataSize
	"SEL"
	^4! !

!ObjectiveCSelector methodsFor: 'converting' stamp: 'EstebanLorenzano 2/18/2011 09:09'!
asObjectiveCSelector 
	^self! !

!ObjectiveCSelector methodsFor: 'converting' stamp: 'EstebanLorenzano 2/8/2011 18:21'!
asSmalltalkSelector
	"Assume the receiver is an Alien for a SEL.  Answer its correspondng Smaltalk selector, or raise an error."
	| resultAlien |
	resultAlien := (ObjCRuntimeRef uniqueInstance selGetName: self).
	resultAlien isObjectiveCNil
		ifTrue: [ self error: 'Alien is nil' ].  
	
	^resultAlien strcpy asSymbol! !

!ObjectiveCSelector methodsFor: 'coercing' stamp: 'EstebanLorenzano 1/13/2011 10:58'!
id
	"Answer the receiver's id. This coerces direct, pointer and indirect ObjectiveC objects correctly."
	^self addressField! !

!Object methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 12:06'!
asObjectiveCAlien
	self shouldBeImplemented! !

!Object methodsFor: '*Alien-MacOSX-Core' stamp: 'EstebanLorenzano 2/18/2011 09:10'!
isAlien
	^false! !

Object subclass: #ObjectiveCProxy
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

ObjectiveCProxy class
	instanceVariableNames: 'callbacks'!

!ObjectiveCProxy commentStamp: '<historical>' prior: 0!
IMPORTANT: I deprecate ObjectiveCSmalltalkObjectProxy, which is kept for now as a reference (Also, I'm not sure I'm complete ok)

I'm a proxy between Smalltalk and ObjectiveC classes. For all purposes, it is an ObjectiveC class which method implementations resides in Smalltalk (using Callback mechanism).
You need to define a method using the pragma "objectiveCSignature:", and you need to declare the proper signature using this nomenclature: http://developer.apple.com/library/mac/#documentation/Cocoa/Conceptual/ObjCRuntimeGuide/Articles/ocrtTypeEncodings.html
For example, this nomenclature: 'c@:^v' means: returns a character, receives a void* (Alien) as a parameter.

You can see examples of me in: MacOSXAlertDelegate and MacOSXTableViewDelegate!

ObjectiveCProxy class
	instanceVariableNames: 'callbacks'!

!ObjectiveCProxy class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:12'!
addCallback: aCallback
	"I keep callbacks to prevent the execution blocks to be garbage collected"
	callbacks ifNil: [ callbacks := Set new ].
	callbacks add: aCallback  ! !

!ObjectiveCProxy class methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/18/2011 12:15'!
ensureNotifiedAtStartup
	Smalltalk addToStartUpList: self after: ObjectiveCClass! !

!ObjectiveCProxy class methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/18/2011 12:15'!
initialize 
	super initialize.
	self ensureNotifiedAtStartup.
	self startUp: true.  ! !

!ObjectiveCProxy class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:10'!
objectiveCClassName
	^self subclassResponsibility! !

!ObjectiveCProxy class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:10'!
objectiveCSuperclassName 
	^'NSObject'! !

!ObjectiveCProxy class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:12'!
resetCallbacks
	callbacks := nil! !

!ObjectiveCProxy class methodsFor: 'system startup' stamp: 'EstebanLorenzano 2/18/2011 12:14'!
startUp: resuming 
	resuming ifTrue: [ 
		self withAllSubclassesDo: #resetCallbacks ]! !

!ObjectiveCProxy methodsFor: 'private' stamp: 'EstebanLorenzano 2/18/2011 12:19'!
addMethod: aSelector signature: aString objectiveC: theClass smalltalk: anObject
	| callback |
	
	callback := self createCallbackFor: aSelector signature: aString target: anObject.
	self class addCallback: callback.
	theClass 
		addMethod: aSelector
		signature: aString
		implementation: callback! !

!ObjectiveCProxy methodsFor: 'private' stamp: 'EstebanLorenzano 2/18/2011 11:59'!
addMethodPragma: aPragma objectiveC: theClass "Alien" smalltalk: targetObject
	| selector signature |
	selector := aPragma method selector.
	signature := aPragma arguments first.
	self 
		addMethod: selector 
		signature: signature
		objectiveC: theClass 
		smalltalk: targetObject 
! !

!ObjectiveCProxy methodsFor: 'converting' stamp: 'EstebanLorenzano 2/18/2011 12:06'!
asObjectiveCAlien 
	^self proxy! !

!ObjectiveCProxy methodsFor: 'private' stamp: 'EstebanLorenzano 2/18/2011 09:33'!
createCallbackFor: aSelector signature: aString target: targetObject
	^Callback 
		block: [ :args :returnAlien | 
			| return |
			return := targetObject 
				perform: aSelector 
				withArguments: (ObjectiveCAlien
					argumentListFromMArgs: args args 
					numArgs: aSelector numArgs 
					withSignature: aString).
			self returnTo: returnAlien signature: aString value: return ]
		argsClass: ObjectiveCForwardSignature! !

!ObjectiveCProxy methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/18/2011 09:24'!
ensureSmalltalkProxy 
	^self objectiveCClassName inObjectiveC 
		ifNil: [ 
			self installSmalltalkProxyClass.
			self objectiveCClassName inObjectiveC ].
! !

!ObjectiveCProxy methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/17/2011 17:32'!
initialize
	| proxyClass |
	super initialize.
	
	proxyClass := self ensureSmalltalkProxy.	
	proxy := proxyClass alloc.! !

!ObjectiveCProxy methodsFor: 'private' stamp: 'EstebanLorenzano 2/18/2011 18:09'!
installSmalltalkProxyClass
	"Installs a new SmalltalkProxy class in the system. 
	 ProxyCallbacks  is a class side attribute to keep the callbacks and prevent them from being 
	 garbage collected"
	
	ObjectiveCClass 
		createClassNamed: self objectiveCClassName 
		superclass: self objectiveCSuperclassName 
		into: [ :theClass :theSuperclass | 
			(Pragma allNamed: #objectiveCSignature: in: self class theMetaClass) 
				do: [ :each | self addMethodPragma: each objectiveC: theClass smalltalk: self ].
			(Pragma allNamed: #objectiveCSignature: in: self class) 
				do: [ :each | self addMethodPragma: each objectiveC: theClass smalltalk: self ] ]. 

! !

!ObjectiveCProxy methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:09'!
objectiveCClassName 
	^self class className! !

!ObjectiveCProxy methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:11'!
objectiveCSuperclassName
	^self class objectiveCSuperclassName! !

!ObjectiveCProxy methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/17/2011 16:35'!
proxy 
	^proxy! !

!ObjectiveCProxy methodsFor: 'private' stamp: 'EstebanLorenzano 2/18/2011 16:19'!
returnTo: returnAlien signature: aString value: anObject    
	| returnValue  |
	
	returnValue := ObjectiveCAlien returnForCallback: anObject withSignature: aString.
	returnValue 
		ifNil: [ ^returnAlien ].
	returnValue isInteger 
		ifTrue: [ ^returnAlien returnInteger: returnValue ].
	returnValue isAlien 
		ifTrue: [ ^returnAlien returnInteger: returnValue addressField ].
	(returnValue isFloat or: [ returnValue isFraction ])
		ifTrue: [ ^returnAlien returnDouble: returnValue asFloat ].
		
	self error: 'Invalid return type'! !

ObjectiveCProxy subclass: #ObjectiveCProxyToSmalltalk
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-MacOSX-Core'!

!ObjectiveCProxyToSmalltalk class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/18/2011 12:01'!
for: anObject
	^self basicNew 
		initialize: anObject;
		yourself! !

!ObjectiveCProxyToSmalltalk methodsFor: 'callbacks' stamp: 'EstebanLorenzano 2/18/2011 12:01'!
forwardInvocation: anObjectiveCAlien "NSInvocation"
	<objectiveCSignature: 'v@:@'>
	self halt.! !

!ObjectiveCProxyToSmalltalk methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/18/2011 12:08'!
initialize: anObject   
	self initialize.
	receiver := anObject! !

!ObjectiveCProxyToSmalltalk methodsFor: 'callbacks' stamp: 'EstebanLorenzano 2/18/2011 12:01'!
performSelector: selectorAlien onThread: threadAlien withObject: objectAlien waitUntilDone: aBoolean
	<objectiveCSignature: 'c@:^v@@c'>
	self halt.
	! !

!ObjectiveCProxyToSmalltalk methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/18/2011 12:01'!
receiver 
	^receiver! !

!ObjectiveCProxyToSmalltalk methodsFor: 'callbacks' stamp: 'EstebanLorenzano 2/18/2011 12:01'!
respondsToSelector: anAlien
	<objectiveCSignature: 'c@:^v'>
	^(self receiver respondsTo: anAlien asObjectiveCSelector asSmalltalkSelector) asAlien! !
ObjectiveCAlien initialize!
ObjectiveCSmalltalkObjectProxy initialize!
ObjectiveCProxy initialize!
